<?php

namespace Assetise\Asset\Actions;

use Illuminate\Support\Carbon;
use Illuminate\Support\Str;
use Litepie\Actions\Concerns\AsAction;
use Litepie\Actions\Traits\LogsActions;
use Litepie\Notification\Traits\SendNotification;
use Assetise\Asset\Models\Condition;


class ConditionAction
{
    use AsAction;

    protected $model;
    protected $namespace = 'assetise.asset.condition';
    protected $eventClass = \Assetise\Asset\Events\ConditionAction::class;
    protected $action;
    protected $function;
    protected $request;

    public function handle(string $action, Condition $condition, array $request = [])
    {
        $this->action = $action;
        $this->request = $request;
        $this->model = $condition;
        $this->function = Str::camel($action);
        $this->executeAction();
        return $this->model;

    }


    public function store(Condition $condition, array $request)
    {
        $attributes = $request;
        $attributes['user_id'] = user_id();
        $attributes['user_type'] = user_type();
        $condition = $condition->create($attributes);
        return $condition;
    }

    public function update(Condition $condition, array $request)
    {
        $attributes = $request;
        $condition->update($attributes);
        return $condition;
    }

    public function destroy(Condition $condition, array $request)
    {
        $condition->delete();
        return $condition;
    }

    public function copy(Condition $condition, array $request)
    {
        $count = $request['count'] ?: 1;

        if ($count == 1) {
            $condition = $condition->replicate();
            $condition->created_at = Carbon::now();
            $condition->save();
            return $condition;
        }

        for ($i = 1; $i <= $count; $i++) {
            $new = $condition->replicate();
            $new->created_at = Carbon::now();
            $new->save();
        }

        return $condition;
    }


}
