<?php

namespace Assetise\Asset\Actions;

use Illuminate\Support\Carbon;
use Illuminate\Support\Str;
use Litepie\Actions\Concerns\AsAction;
use Litepie\Actions\Traits\LogsActions;
use Litepie\Notification\Traits\SendNotification;
use Assetise\Asset\Models\Consequence;


class ConsequenceAction
{
    use AsAction;

    protected $model;
    protected $namespace = 'assetise.asset.consequence';
    protected $eventClass = \Assetise\Asset\Events\ConsequenceAction::class;
    protected $action;
    protected $function;
    protected $request;

    public function handle(string $action, Consequence $consequence, array $request = [])
    {
        $this->action = $action;
        $this->request = $request;
        $this->model = $consequence;
        $this->function = Str::camel($action);
        $this->executeAction();
        return $this->model;

    }


    public function store(Consequence $consequence, array $request)
    {
        $attributes = $request;
        $attributes['user_id'] = user_id();
        $attributes['user_type'] = user_type();
        $consequence = $consequence->create($attributes);
        return $consequence;
    }

    public function update(Consequence $consequence, array $request)
    {
        $attributes = $request;
        $consequence->update($attributes);
        return $consequence;
    }

    public function destroy(Consequence $consequence, array $request)
    {
        $consequence->delete();
        return $consequence;
    }

    public function copy(Consequence $consequence, array $request)
    {
        $count = $request['count'] ?: 1;

        if ($count == 1) {
            $consequence = $consequence->replicate();
            $consequence->created_at = Carbon::now();
            $consequence->save();
            return $consequence;
        }

        for ($i = 1; $i <= $count; $i++) {
            $new = $consequence->replicate();
            $new->created_at = Carbon::now();
            $new->save();
        }

        return $consequence;
    }


}
